#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QFileDialog>
#include <QInputDialog>
#include <QMessageBox>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <QDesktopServices>
#include <QString>
#include <QUrl>
#include <QDir>
#include <QProcess>
#include <QTimer>
#include "pbi.h"

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();


private slots:
    void Reset_Form();  
    void on_actionExit_triggered();
    void on_pushFindIcon_clicked();
    void on_actionAbout_EasyPBI_triggered();
    void on_actionAppCafe_Integration_triggered();
    void on_pushNewModule_clicked();
    void on_create_button_clicked();
    void on_port_info_button_clicked();
    int Check_For_Ports(bool show_warning);
    void on_actionGet_Ports_triggered();
    void downloadFinished(QNetworkReply *reply);
    void extractPT();
    void updateProgress(qint64,qint64);
    void on_pushSavePBISettings_clicked();
    void on_pushChangeOutDir_clicked();
    void on_pushChangeSigFile_clicked();
    void on_pushSelectModule_clicked();
    void on_pushBuildPBI_clicked();
    void PBIbuildFinished(int,QProcess::ExitStatus);
    void updatePBIBuild();
    void killPBIBuild();
    void buildError(QProcess::ProcessError);
    void on_pushSaveLog_clicked();
    
private:
    Ui::MainWindow *ui;
    void SetupDefaults();
    void loadPBISettings();
    QString PROG_DIR, PORTS_DIR, PORT_SELECTED, PBIOUT_DIR, MODOUT_DIR, PROGVERSION, PBISETTINGS_FILE;
    QProcess *p;
    PBI_Struct *pbi_data;
};

#endif // MAINWINDOW_H
